Funzione Part

From FreeCAD Documentation
Revision as of 15:47, 20 November 2019 by Renatorivo (talk | contribs) (Created page with "Vedere Proprietà per tutti i tipi di proprietà che possono avere oggetti con script.")

Introduzione

Un oggetto Part Feature, o formalmente un Part::Feature, è un elemento semplice a cui è associato un Shape topologico che può essere visualizzato nella Vista 3D.

L'oggetto Part::Feature è definito in Part ma può essere usato come classe base per script di oggetti in tutti gli [[Workbenches/it|ambienti] ] che producono forme geometriche 2D e 3D.

Un oggetto Part::Feature ha proprietà semplici come il posizionamento e i colori per definire l'aspetto dei suoi vertici, bordi e facce. Gli ambienti possono aggiungere altre proprietà a questo elemento di base per produrre un oggetto con un comportamento complesso.

Proprietà

Vedere Proprietà per tutti i tipi di proprietà che possono avere oggetti con script.

These are the properties available in the property editor.

Dati

Base

  • DatiPlacement: the position of the object in the 3D view. The placement is defined by a Base point (vector), and a Rotation (axis and angle).
    • DatiAngle: the angle of rotation around the DatiAxis.
    • DatiAxis: the unit vector that defines the axis of rotation for the placement. Each value is between 0 and 1. If any value is above 1, the vector is normalized so that the magnitude of the vector is 1.
    • DatiPosition: the 3D coordinates of the base point of the placement.
  • DatiLabel: the user editable description of this object.

Vista

Base

  • VistaAngular Deflection: it is a companion to VistaDeviation. It is another way to specify how finely to generate the mesh for rendering on screen or when exporting. The default value is 28.5 degrees, or 0.5 radians. The smaller the value the smoother the appearance will be in the 3D view, and the finer the mesh that will be exported.
  • VistaBounding Box: if it is true, the object will show the bounding box in the 3D view.
  • VistaDeviation: it is a companion to VistaAngular Deflection. It is another way to specify how finely to generate the mesh for rendering on screen or when exporting. The default value is 0.5. The smaller the value the smoother the appearance will be in the 3D view, and the finer the mesh that will be exported.
  • VistaDisplay Mode: Flat Lines (regular visualization), Shaded (soft edges), Wireframe (no faces), Points (only vertices).
  • VistaDraw Style: Solid, Dashed, Dotted, Dashdot; defines the style of the edges in the 3D view.
  • VistaLighting: Two side, One side; the illumination comes from two sides or one side in the 3D view.
  • VistaLine Color: a tuple of three values (r,g,b) to define the color of the edges in the 3D view.
  • VistaLine Width: a float that determines the width in pixels of the edges in the 3D view.
  • VistaOn Top When Selected: Disabled, Enabled, Object, Element.
  • VistaPoint Color: a tuple of three values (r,g,b) to define the color of the vertices in the 3D view.
  • VistaPoint Size: a float that determines the size in pixels of the vertices in the 3D view.
  • VistaSelectable: if it is true, the object can be picked with the pointer in the 3D view. Otherwise, the object cannot be selected until this option is set to true.
  • VistaSelection Style: Shape, BoundBox.
  • VistaShape Color: a tuple of three values (r,g,b) to define the color of the faces in the 3D view.
  • VistaShow In Tree: if it is true, the object appears in the tree view. Otherwise, it is set as invisible.
  • VistaTransparency: a float from 0 to 100 that determines the level of transparency of the faces in the 3D view. A value of 100 indicates completely invisible faces; the faces are invisible but they can still be picked as long as VistaSelectable is true.
  • VistaVisibility: if it is true, the object appears in the 3D view; otherwise it is not present.

Scripting

See also: FreeCAD Scripting Basics, and scripted objects.

A Part Feature is created with the addObject() method of the document.

obj = App.ActiveDocument.addObject("Part::Feature", "Name")
obj.Label = "Custom label"
  • The first argument indicates the type of object, in this case, "Part::Feature".
  • The second argument is a string that defines the Name attribute. If it is not provided, it defaults to "Part__Feature".
    • The Name is fixed at creation time; it cannot be modified afterwards.
    • The Name can only include simple alphanumeric characters, and the underscore, [_0-9a-zA-Z]. If other symbols are given, these will be converted to underscores; for example, "A+B:C*" is converted to "A_B_C_".
    • The Name must be unique in the entire document. If more objects with the same name are created, a sequential number will be appended to distinguish them, for example, "Name001", "Name002", etc.
  • If desired, the Label attribute can be changed to a more meaningful text.
    • By default, the Label is equal to the Name.
    • Unlike the Name, the Label can accept any UTF8 string, including accents and spaces. Since the tree view displays the Label, it is a good practice to change the Label to a more descriptive string.
    • By default the Label must be unique. This behavior can be changed in the preferences editor, Edit → Preferences → General → Document → Allow duplicate object labels in one document.